<?php
/*************************************************************/
/*		constants definitions              	     */
/*************************************************************/

define("CHAT_FILE" , "/tmp/chat-file.txt");
define("CHAT_USERS" , "/tmp/chat-users.txt");
define("VERSION","2.6");
/*************************************************************/
/*		functions definitions              	     */
/*************************************************************/

function  ShowHeader($specialmeta ="") {
?>
<html>
<head>
   <title>Web chat</title>
   <meta name="author" content="Minta Adrian">
   <meta name="generator" content="PHPWebChat">
<? print($specialmeta) ?>
</head>
<body text="#a20000" bgcolor="#d8cec2" link="#0000ff" vlink="#0000ff" alink="#ff0000">
<?
}

function ReportError() {
    ShowHeader();
    ?>  
    <center> <font size=+12 >You must login first !</font><br>
    <br><br>
    <font size=+2>
    <a href="chat.php"> Login page </a>
    </font></center>

    <?php
    die("\n</body></html>");
}

function CheckInfo() {
    global  $CHAT_USER_NAME, $CHAT_USER_REFRESH, $CHAT_USER_ID;
    if( (!isset($CHAT_USER_NAME))||(!isset($CHAT_USER_ID)) ) {
	ShowHeader();
	?>  
            <center> <font size=+12 >You must login first !</font><br>
            <br><br>
            <font size=+2>
            <a href="chat.php"> Login page </a>
            </font></center>

        <?php
    	die("\n</body></html>");
    }
}

function FancyDate($a_date = 0) {
    if($a_date == 0 ) $a_date = getdate(time());
    $date = sprintf("%s %s %s %s.%s.%s", $a_date["mday"],
		$a_date["month"],$a_date["year"],$a_date["hours"],
		$a_date["minutes"],$a_date["seconds"]);
    return $date;
}

function UserLeft($name,$ip,$lastdate) {
//format the message for user left
    $date=FancyDate($lastdate);
    return sprintf("<center><i><font color=red>%s - %s from %s has left the chat </font></center></i>\n",$date,$name,$ip);
}

function CleanString($ustr) {
    $ustr= ereg_replace("<[^>]*>",".",$ustr);

    $ustr= ereg_replace("&[^;]*;",".",$ustr);
    $ustr= str_replace(":",".",$ustr);
    $ustr= str_replace("<",".",$ustr);
    $ustr= str_replace(">",".",$ustr);
    $ustr= str_replace("\"",".",$ustr);
    $ustr= str_replace("\\",".",$ustr);

    return $ustr;
}					      

/*************************************************************/
/*		database functions              	     */
/*************************************************************/

function CDBsearch( $name , $userid = 0) {
// search the database for user an return 0 if user exist -1 if not
// if $userid is not set the search is done only by $name 
// TRUE=1 FALSE=0
    $dbfile = fopen(CHAT_USERS,"r");
    $content = fread($dbfile, filesize( CHAT_USERS ) );
    fclose($dbfile);  
    $lines = explode("\n",$content);
    foreach ($lines as $line) {
	list ( $dbname , $dbip, $dbtime, $dbuserid) = explode( ':',$line);
	if( ($userid != 0)&&($name==$dbname)&&($userid==$dbuserid) ) return 1;
	if( ($userid == 0)&&($name==$dbname) ) return 1;
    }
return 0;    	 
}

function CDBretrieveid( $name ) {
// search the database for user and return the user ID or 0 if the user don't exist
// TRUE=1 FALSE=0
    $dbfile = fopen(CHAT_USERS,"r");
    $content = fread($dbfile, filesize( CHAT_USERS ) );
    fclose($dbfile);  
    $lines = explode("\n",$content);
    foreach ($lines as $line) {
	list ( $dbname , $dbip, $dbtime, $dbuserid) = explode( ':',$line);
	if( $name==$dbname) return $dbuserid;
    }
return 0;    	 
}

function CDBinsert( $name, $ip, $userid) {
//insert a new user in database
    $dbfile = fopen(CHAT_USERS,"a+");
    $info=sprintf("%s:%s:%d:%s\n",$name,$ip,time(),$userid);
    fputs($dbfile, $info);
    fclose($dbfile);
}    

function CDBupdate( $name ) {
//update the database 
    $dbfile = fopen(CHAT_USERS,"r+");
    $content = fread($dbfile, filesize( CHAT_USERS ) );
    fclose($dbfile);
    
    $ntime = time();
    $lines = explode("\n",$content);
    foreach ($lines as $line) {
	list ( $dbname , $dbip, $dbtime, $dbuserid) = explode( ':',$line);
	if($name==$dbname) $dbtime=$ntime;
	if( ($ntime-$dbtime) < 30 )  $ncontent = sprintf("%s:%s:%d:%s\n%s",$dbname,$dbip,$dbtime,$dbuserid,$ncontent);
	else if(strlen($dbname)>0) $rezmsg=sprintf("%s\n%s",$rezmsg,UserLeft($dbname,$dbip,getdate($dbtime)));
    }
    
    $dbfile = fopen(CHAT_USERS,"w");
    fputs($dbfile,$ncontent);
    fclose($dbfile);
    return $rezmsg;
}    

function CDBdump() {
//dump the database content 
    $dbfile = fopen(CHAT_USERS,"r");
    $content = fread($dbfile, filesize( CHAT_USERS ) );
    fclose($dbfile);
    return $content;
}    

function CDBstatistics() {
//dump the database content 
    $dbfile = fopen(CHAT_USERS,"r");
    $content = fread($dbfile, filesize( CHAT_USERS ) );
    fclose($dbfile);
    $lines = explode("\n",$content);
    $numberofusers = sizeof($lines) - 1;
    return $numberofusers;
}    

?>